-------------------------------------------------------------------------------
-- eeprom_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library eeprom_v1_00_a;
use eeprom_v1_00_a.All;

entity eeprom_0_wrapper is
  port (
    DQ0_T : out std_logic;
    DQ0_O : out std_logic;
    DQ0_I : in std_logic;
    DQ1_T : out std_logic;
    DQ1_O : out std_logic;
    DQ1_I : in std_logic;
    DQ2_T : out std_logic;
    DQ2_O : out std_logic;
    DQ2_I : in std_logic;
    DQ3_T : out std_logic;
    DQ3_O : out std_logic;
    DQ3_I : in std_logic;
    DQ4_T : out std_logic;
    DQ4_O : out std_logic;
    DQ4_I : in std_logic;
    DQ5_T : out std_logic;
    DQ5_O : out std_logic;
    DQ5_I : in std_logic;
    DQ6_T : out std_logic;
    DQ6_O : out std_logic;
    DQ6_I : in std_logic;
    DQ7_T : out std_logic;
    DQ7_O : out std_logic;
    DQ7_I : in std_logic;
    OPB_Clk : in std_logic;
    OPB_Rst : in std_logic;
    Sl_DBus : out std_logic_vector(0 to 31);
    Sl_errAck : out std_logic;
    Sl_retry : out std_logic;
    Sl_toutSup : out std_logic;
    Sl_xferAck : out std_logic;
    OPB_ABus : in std_logic_vector(0 to 31);
    OPB_BE : in std_logic_vector(0 to 3);
    OPB_DBus : in std_logic_vector(0 to 31);
    OPB_RNW : in std_logic;
    OPB_select : in std_logic;
    OPB_seqAddr : in std_logic
  );
  attribute x_core_info : STRING;
  attribute x_core_info of eeprom_0_wrapper: entity is "eeprom_v1_00_a";

end eeprom_0_wrapper;

architecture STRUCTURE of eeprom_0_wrapper is

  component eeprom is
    generic (
      C_BASEADDR : std_logic_vector;
      C_HIGHADDR : std_logic_vector;
      C_OPB_AWIDTH : INTEGER;
      C_OPB_DWIDTH : INTEGER;
      C_USER_ID_CODE : INTEGER;
      C_FAMILY : STRING
    );
    port (
      DQ0_T : out std_logic;
      DQ0_O : out std_logic;
      DQ0_I : in std_logic;
      DQ1_T : out std_logic;
      DQ1_O : out std_logic;
      DQ1_I : in std_logic;
      DQ2_T : out std_logic;
      DQ2_O : out std_logic;
      DQ2_I : in std_logic;
      DQ3_T : out std_logic;
      DQ3_O : out std_logic;
      DQ3_I : in std_logic;
      DQ4_T : out std_logic;
      DQ4_O : out std_logic;
      DQ4_I : in std_logic;
      DQ5_T : out std_logic;
      DQ5_O : out std_logic;
      DQ5_I : in std_logic;
      DQ6_T : out std_logic;
      DQ6_O : out std_logic;
      DQ6_I : in std_logic;
      DQ7_T : out std_logic;
      DQ7_O : out std_logic;
      DQ7_I : in std_logic;
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Sl_DBus : out std_logic_vector(0 to (C_OPB_DWIDTH-1));
      Sl_errAck : out std_logic;
      Sl_retry : out std_logic;
      Sl_toutSup : out std_logic;
      Sl_xferAck : out std_logic;
      OPB_ABus : in std_logic_vector(0 to (C_OPB_AWIDTH-1));
      OPB_BE : in std_logic_vector(0 to ((C_OPB_DWIDTH/8)-1));
      OPB_DBus : in std_logic_vector(0 to (C_OPB_DWIDTH-1));
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic
    );
  end component;

begin

  eeprom_0 : eeprom
    generic map (
      C_BASEADDR => X"7be00000",
      C_HIGHADDR => X"7be0ffff",
      C_OPB_AWIDTH => 32,
      C_OPB_DWIDTH => 32,
      C_USER_ID_CODE => 3,
      C_FAMILY => "virtex2p"
    )
    port map (
      DQ0_T => DQ0_T,
      DQ0_O => DQ0_O,
      DQ0_I => DQ0_I,
      DQ1_T => DQ1_T,
      DQ1_O => DQ1_O,
      DQ1_I => DQ1_I,
      DQ2_T => DQ2_T,
      DQ2_O => DQ2_O,
      DQ2_I => DQ2_I,
      DQ3_T => DQ3_T,
      DQ3_O => DQ3_O,
      DQ3_I => DQ3_I,
      DQ4_T => DQ4_T,
      DQ4_O => DQ4_O,
      DQ4_I => DQ4_I,
      DQ5_T => DQ5_T,
      DQ5_O => DQ5_O,
      DQ5_I => DQ5_I,
      DQ6_T => DQ6_T,
      DQ6_O => DQ6_O,
      DQ6_I => DQ6_I,
      DQ7_T => DQ7_T,
      DQ7_O => DQ7_O,
      DQ7_I => DQ7_I,
      OPB_Clk => OPB_Clk,
      OPB_Rst => OPB_Rst,
      Sl_DBus => Sl_DBus,
      Sl_errAck => Sl_errAck,
      Sl_retry => Sl_retry,
      Sl_toutSup => Sl_toutSup,
      Sl_xferAck => Sl_xferAck,
      OPB_ABus => OPB_ABus,
      OPB_BE => OPB_BE,
      OPB_DBus => OPB_DBus,
      OPB_RNW => OPB_RNW,
      OPB_select => OPB_select,
      OPB_seqAddr => OPB_seqAddr
    );

end architecture STRUCTURE;

