-------------------------------------------------------------------------------
-- ofdm_txrx_mimo_opbw_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library ofdm_TxRx_mimo_opbw_v1_13_a;
use ofdm_TxRx_mimo_opbw_v1_13_a.All;

entity ofdm_txrx_mimo_opbw_0_wrapper is
  port (
    ce : in std_logic;
    debug_chipscopetrig : in std_logic;
    opb_abus : in std_logic_vector(0 to 31);
    opb_be : in std_logic_vector(0 to 3);
    opb_clk : in std_logic;
    opb_dbus : in std_logic_vector(0 to 31);
    opb_rnw : in std_logic;
    opb_rst : in std_logic;
    opb_select : in std_logic;
    opb_seqaddr : in std_logic;
    rx_anta_adci_dv4 : in std_logic_vector(0 to 13);
    rx_anta_adcq_dv4 : in std_logic_vector(0 to 13);
    rx_antb_adci_dv4 : in std_logic_vector(0 to 13);
    rx_antb_adcq_dv4 : in std_logic_vector(0 to 13);
    rx_extpktdet : in std_logic;
    rx_reset : in std_logic;
    tx_reset : in std_logic;
    tx_starttransmit : in std_logic;
    rx_debug_eq_i : out std_logic_vector(0 to 13);
    rx_debug_eq_q : out std_logic_vector(0 to 13);
    rx_debug_payload : out std_logic;
    rx_debug_pktdone : out std_logic;
    rx_int_badpkt : out std_logic;
    rx_int_goodpkt : out std_logic;
    rx_pktdetreset : out std_logic;
    sgp_dbus : out std_logic_vector(0 to 31);
    sgp_errack : out std_logic;
    sgp_retry : out std_logic;
    sgp_toutsup : out std_logic;
    sgp_xferack : out std_logic;
    tx_anta_dac_i : out std_logic_vector(0 to 15);
    tx_anta_dac_q : out std_logic_vector(0 to 15);
    tx_antb_dac_i : out std_logic_vector(0 to 15);
    tx_antb_dac_q : out std_logic_vector(0 to 15);
    tx_debug_pktrunning : out std_logic
  );
  attribute x_core_info : STRING;
  attribute x_core_info of ofdm_txrx_mimo_opbw_0_wrapper: entity is "ofdm_TxRx_mimo_opbw_v1_13_a";

end ofdm_txrx_mimo_opbw_0_wrapper;

architecture STRUCTURE of ofdm_txrx_mimo_opbw_0_wrapper is

  component ofdm_txrx_mimo_opbw is
    generic (
      C_BASEADDR : std_logic_vector(0 to 31);
      C_HIGHADDR : std_logic_vector(0 to 31);
      C_OPB_AWIDTH : INTEGER;
      C_OPB_DWIDTH : INTEGER
    );
    port (
      ce : in std_logic;
      debug_chipscopetrig : in std_logic;
      opb_abus : in std_logic_vector(0 to 31);
      opb_be : in std_logic_vector(0 to 3);
      opb_clk : in std_logic;
      opb_dbus : in std_logic_vector(0 to 31);
      opb_rnw : in std_logic;
      opb_rst : in std_logic;
      opb_select : in std_logic;
      opb_seqaddr : in std_logic;
      rx_anta_adci_dv4 : in std_logic_vector(0 to 13);
      rx_anta_adcq_dv4 : in std_logic_vector(0 to 13);
      rx_antb_adci_dv4 : in std_logic_vector(0 to 13);
      rx_antb_adcq_dv4 : in std_logic_vector(0 to 13);
      rx_extpktdet : in std_logic;
      rx_reset : in std_logic;
      tx_reset : in std_logic;
      tx_starttransmit : in std_logic;
      rx_debug_eq_i : out std_logic_vector(0 to 13);
      rx_debug_eq_q : out std_logic_vector(0 to 13);
      rx_debug_payload : out std_logic;
      rx_debug_pktdone : out std_logic;
      rx_int_badpkt : out std_logic;
      rx_int_goodpkt : out std_logic;
      rx_pktdetreset : out std_logic;
      sgp_dbus : out std_logic_vector(0 to 31);
      sgp_errack : out std_logic;
      sgp_retry : out std_logic;
      sgp_toutsup : out std_logic;
      sgp_xferack : out std_logic;
      tx_anta_dac_i : out std_logic_vector(0 to 15);
      tx_anta_dac_q : out std_logic_vector(0 to 15);
      tx_antb_dac_i : out std_logic_vector(0 to 15);
      tx_antb_dac_q : out std_logic_vector(0 to 15);
      tx_debug_pktrunning : out std_logic
    );
  end component;

begin

  ofdm_txrx_mimo_opbw_0 : ofdm_txrx_mimo_opbw
    generic map (
      C_BASEADDR => X"77200000",
      C_HIGHADDR => X"772fffff",
      C_OPB_AWIDTH => 32,
      C_OPB_DWIDTH => 32
    )
    port map (
      ce => ce,
      debug_chipscopetrig => debug_chipscopetrig,
      opb_abus => opb_abus,
      opb_be => opb_be,
      opb_clk => opb_clk,
      opb_dbus => opb_dbus,
      opb_rnw => opb_rnw,
      opb_rst => opb_rst,
      opb_select => opb_select,
      opb_seqaddr => opb_seqaddr,
      rx_anta_adci_dv4 => rx_anta_adci_dv4,
      rx_anta_adcq_dv4 => rx_anta_adcq_dv4,
      rx_antb_adci_dv4 => rx_antb_adci_dv4,
      rx_antb_adcq_dv4 => rx_antb_adcq_dv4,
      rx_extpktdet => rx_extpktdet,
      rx_reset => rx_reset,
      tx_reset => tx_reset,
      tx_starttransmit => tx_starttransmit,
      rx_debug_eq_i => rx_debug_eq_i,
      rx_debug_eq_q => rx_debug_eq_q,
      rx_debug_payload => rx_debug_payload,
      rx_debug_pktdone => rx_debug_pktdone,
      rx_int_badpkt => rx_int_badpkt,
      rx_int_goodpkt => rx_int_goodpkt,
      rx_pktdetreset => rx_pktdetreset,
      sgp_dbus => sgp_dbus,
      sgp_errack => sgp_errack,
      sgp_retry => sgp_retry,
      sgp_toutsup => sgp_toutsup,
      sgp_xferack => sgp_xferack,
      tx_anta_dac_i => tx_anta_dac_i,
      tx_anta_dac_q => tx_anta_dac_q,
      tx_antb_dac_i => tx_antb_dac_i,
      tx_antb_dac_q => tx_antb_dac_q,
      tx_debug_pktrunning => tx_debug_pktrunning
    );

end architecture STRUCTURE;

