#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"
#include "xparameters.h"

#define OFDM_AGC_MIMO_OFFSET (0x00000000)
//Gateways In

#define OFDM_AGC_MIMO_ADJ_OFFSET (OFDM_AGC_MIMO_OFFSET+0x0)
//tag name: in_0
//arith_type = Signed  (2's comp)
//num_bits = 16
//bin_pt = 0
#define OFDM_AGC_MIMO_DCOTiming_OFFSET (OFDM_AGC_MIMO_OFFSET+0x4)
//tag name: in_1
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define OFDM_AGC_MIMO_GBB_init_OFFSET (OFDM_AGC_MIMO_OFFSET+0x8)
//tag name: in_2
//arith_type = Signed  (2's comp)
//num_bits = 8
//bin_pt = 0
#define OFDM_AGC_MIMO_T_dB_OFFSET (OFDM_AGC_MIMO_OFFSET+0xC)
//tag name: in_3
//arith_type = Signed  (2's comp)
//num_bits = 8
//bin_pt = 0
#define OFDM_AGC_MIMO_Thresholds_OFFSET (OFDM_AGC_MIMO_OFFSET+0x10)
//tag name: in_4
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define OFDM_AGC_MIMO_Timing_OFFSET (OFDM_AGC_MIMO_OFFSET+0x14)
//tag name: in_5
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define OFDM_AGC_MIMO_AGC_EN_OFFSET (OFDM_AGC_MIMO_OFFSET+0x18)
//tag name: in_6
//arith_type = Boolean
//num_bits = 10
//bin_pt = 0
#define OFDM_AGC_MIMO_AVG_LEN_OFFSET (OFDM_AGC_MIMO_OFFSET+0x1C)
//tag name: in_7
//arith_type = Unsigned
//num_bits = 16
//bin_pt = 0
#define OFDM_AGC_MIMO_BitsIn_OFFSET (OFDM_AGC_MIMO_OFFSET+0x20)
//tag name: in_8
//arith_type = Unsigned
//num_bits = 6
//bin_pt = 0
#define OFDM_AGC_MIMO_MRESET_IN_OFFSET (OFDM_AGC_MIMO_OFFSET+0x24)
//tag name: in_9
//arith_type = Boolean
//num_bits = 10
//bin_pt = 0
#define OFDM_AGC_MIMO_SRESET_IN_OFFSET (OFDM_AGC_MIMO_OFFSET+0x28)
//tag name: in_10
//arith_type = Boolean
//num_bits = 10
//bin_pt = 0

//Gateways Out

#define OFDM_AGC_MIMO_G_BB_A_reg_OFFSET (OFDM_AGC_MIMO_OFFSET+0x2C)
//tag name: out_11
#define OFDM_AGC_MIMO_G_BB_B_reg_OFFSET (OFDM_AGC_MIMO_OFFSET+0x30)
//tag name: out_12
#define OFDM_AGC_MIMO_G_RF_A_reg_OFFSET (OFDM_AGC_MIMO_OFFSET+0x34)
//tag name: out_13
#define OFDM_AGC_MIMO_G_RF_B_reg_OFFSET (OFDM_AGC_MIMO_OFFSET+0x38)
//tag name: out_14


#define OFDM_AGC_MIMO_WriteReg(BaseAddress, RegOffset, Data) \
	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

#define OFDM_AGC_MIMO_ReadReg(BaseAddress, RegOffset) \
	XIo_In32((BaseAddress) + (RegOffset))

//Write Reg Macro

#define OFDM_AGC_MIMO_WriteReg_ADJ(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_ADJ_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_DCOTiming(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_DCOTiming_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_GBB_init(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_GBB_init_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_T_dB(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_T_dB_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_Thresholds(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_Thresholds_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_Timing(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_Timing_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_AGC_EN(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_AGC_EN_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_AVG_LEN(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_AVG_LEN_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_BitsIn(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_BitsIn_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_MRESET_IN(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_MRESET_IN_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_SRESET_IN(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_SRESET_IN_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_G_BB_A_reg(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_G_BB_A_reg_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_G_BB_B_reg(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_G_BB_B_reg_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_G_RF_A_reg(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_G_RF_A_reg_OFFSET), (Xuint32)(Value))
#define OFDM_AGC_MIMO_WriteReg_G_RF_B_reg(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (OFDM_AGC_MIMO_G_RF_B_reg_OFFSET), (Xuint32)(Value))


//Read Reg Macro

#define OFDM_AGC_MIMO_ReadReg_ADJ(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_ADJ_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_DCOTiming(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_DCOTiming_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_GBB_init(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_GBB_init_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_T_dB(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_T_dB_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_Thresholds(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_Thresholds_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_Timing(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_Timing_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_AGC_EN(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_AGC_EN_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_AVG_LEN(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_AVG_LEN_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_BitsIn(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_BitsIn_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_MRESET_IN(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_MRESET_IN_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_SRESET_IN(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_SRESET_IN_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_G_BB_A_reg(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_G_BB_A_reg_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_G_BB_B_reg(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_G_BB_B_reg_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_G_RF_A_reg(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_G_RF_A_reg_OFFSET))
#define OFDM_AGC_MIMO_ReadReg_G_RF_B_reg(BaseAddress) \
	XIo_In32((BaseAddress) + (OFDM_AGC_MIMO_G_RF_B_reg_OFFSET))

void ofdm_AGC_SetTarget(unsigned int target);
void ofdm_AGC_SetDCO(unsigned int AGCstate);
void ofdm_AGC_FiltSel(unsigned int AGCstate);
void ofdm_AGC_Reset();
void ofdm_AGC_MasterReset();
void ofdm_AGC_Initialize(int noise_estimate);
void ofdm_AGC_setNoiseEstimate(int noise_estimate);
unsigned int ofdm_AGC_GetGains(void);
