#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:C:\work\edk\warpmac_csmaMac_multihop_noMalloc\system.xmp
#################################################################

XILINX_EDK_DIR = C:/EDK

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex2p

DEVICE = xc2vp70ff1517-6

LANGUAGE = vhdl

SEARCHPATHOPT = 

SUBMODULE_OPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT)

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(DEVICE) $(SEARCHPATHOPT)

VPGEN_OPTIONS = -p $(DEVICE) $(SEARCHPATHOPT)

CSMAMAC_OUTPUT_DIR = csmaMac
CSMAMAC_OUTPUT = $(CSMAMAC_OUTPUT_DIR)/executable.elf

MICROBLAZE_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/microblaze/mb_bootloop.elf
PPC405_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc405/ppc_bootloop.elf
PPC440_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc440/ppc440_bootloop.elf
BOOTLOOP_DIR = bootloops

PPC405_1_BOOTLOOP = $(BOOTLOOP_DIR)/ppc405_1.elf

PPC405_0_BOOTLOOP = $(BOOTLOOP_DIR)/ppc405_0.elf

BRAMINIT_ELF_FILES =  $(CSMAMAC_OUTPUT) 
BRAMINIT_ELF_FILE_ARGS =   -pe ppc405_0 $(CSMAMAC_OUTPUT) 

ALL_USER_ELF_FILES = $(CSMAMAC_OUTPUT) 

SIM_CMD = vsim

BEHAVIORAL_SIM_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_SIM_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_SIM_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_SCRIPT = $(BEHAVIORAL_SIM_SCRIPT)

MIX_LANG_SIM_OPT = -mixed yes

SIMGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(BRAMINIT_ELF_FILE_ARGS) $(MIX_LANG_SIM_OPT)  -s mti


LIBRARIES =  \
       ppc405_1/lib/libxil.a  \
       ppc405_0/lib/libxil.a 
VPEXEC = virtualplatform/vpexec.exe

LIBSCLEAN_TARGETS = ppc405_1_libsclean ppc405_0_libsclean 

PROGRAMCLEAN_TARGETS = csmaMac_programclean 

CORE_STATE_DEVELOPMENT_FILES = 

WRAPPER_NGC_FILES = implementation/reset_block_wrapper.ngc \
implementation/radio_controller_0_wrapper.ngc \
implementation/radio_bridge_slot_2_wrapper.ngc \
implementation/radio_bridge_slot_1_wrapper.ngc \
implementation/ppc405_1_wrapper.ngc \
implementation/ppc405_0_wrapper.ngc \
implementation/plb_bram_if_cntlr_1_bram_wrapper.ngc \
implementation/plb_bram_if_cntlr_1_wrapper.ngc \
implementation/plb2opb_wrapper.ngc \
implementation/plb_wrapper.ngc \
implementation/opb_intc_0_wrapper.ngc \
implementation/opb_wrapper.ngc \
implementation/ofdm_pktdetector_mimo_opbw_0_wrapper.ngc \
implementation/ofdm_txrx_mimo_opbw_0_wrapper.ngc \
implementation/jtagppc_0_wrapper.ngc \
implementation/isocm_bram_wrapper.ngc \
implementation/iocm_cntlr_wrapper.ngc \
implementation/iocm_wrapper.ngc \
implementation/dsocm_bram_wrapper.ngc \
implementation/docm_cntlr_wrapper.ngc \
implementation/docm_wrapper.ngc \
implementation/dcm_0_wrapper.ngc \
implementation/analog_bridge_0_wrapper.ngc \
implementation/sysace_compactflash_wrapper.ngc \
implementation/sram1_zbt_512kx32_util_bus_split_1_wrapper.ngc \
implementation/sram1_zbt_512kx32_wrapper.ngc \
implementation/sram0_zbt_512kx32_util_bus_split_0_wrapper.ngc \
implementation/sram0_zbt_512kx32_wrapper.ngc \
implementation/rs232_wrapper.ngc \
implementation/push_buttons_4bit_wrapper.ngc \
implementation/leds_4bit_wrapper.ngc \
implementation/led_7segment_1_wrapper.ngc \
implementation/led_7segment_wrapper.ngc \
implementation/ethernet_mac_wrapper.ngc \
implementation/eeprom_0_wrapper.ngc \
implementation/dipsws_4bit_wrapper.ngc \
implementation/clkbrdconfig_0_wrapper.ngc \
implementation/ofdm_timer_opbw_0_wrapper.ngc

POSTSYN_NETLIST = implementation/$(SYSTEM).ngc

SYSTEM_BIT = implementation/$(SYSTEM).bit

DOWNLOAD_BIT = implementation/download.bit

SYSTEM_ACE = implementation/$(SYSTEM).ace

UCF_FILE = data/system.ucf

BMM_FILE = implementation/$(SYSTEM).bmm

BITGEN_UT_FILE = etc/bitgen.ut

XFLOW_OPT_FILE = etc/fast_runtime.opt
XFLOW_DEPENDENCY = __xps/xpsxflow.opt $(XFLOW_OPT_FILE)

XPLORER_DEPENDENCY = __xps/xplorer.opt
XPLORER_OPTIONS = -p $(DEVICE) -uc $(SYSTEM).ucf -bm $(SYSTEM).bmm -max_runs 7

FPGA_IMP_DEPENDENCY = $(BMM_FILE) $(POSTSYN_NETLIST) $(UCF_FILE) $(BITGEN_UT_FILE) $(XFLOW_DEPENDENCY)

#################################################################
# SOFTWARE APPLICATION CSMAMAC
#################################################################

CSMAMAC_SOURCES = src/warpmac.c src/csmaMac.c 

CSMAMAC_HEADERS = src/warpmac.h 

CSMAMAC_CC = powerpc-eabi-gcc
CSMAMAC_CC_SIZE = powerpc-eabi-size
CSMAMAC_CC_OPT = -O2
CSMAMAC_CFLAGS = 
CSMAMAC_CC_SEARCH = # -B
CSMAMAC_LIBPATH = -L./ppc405_0/lib/ # -L
CSMAMAC_INCLUDES = -I./ppc405_0/include/  -Isrc/ # -I
CSMAMAC_LFLAGS = # -l
CSMAMAC_LINKER_SCRIPT = csmaMac_linker_script.ld
CSMAMAC_LINKER_SCRIPT_FLAG = -Wl,-T -Wl,$(CSMAMAC_LINKER_SCRIPT) 
CSMAMAC_CC_DEBUG_FLAG =  -g 
CSMAMAC_CC_PROFILE_FLAG = # -pg
CSMAMAC_CC_GLOBPTR_FLAG= # -msdata=eabi
CSMAMAC_CC_START_ADDR_FLAG=  #  # -Wl,-defsym -Wl,_START_ADDR=
CSMAMAC_CC_STACK_SIZE_FLAG=  #  # -Wl,-defsym -Wl,_STACK_SIZE=
CSMAMAC_CC_HEAP_SIZE_FLAG=  #  # -Wl,-defsym -Wl,_HEAP_SIZE=
CSMAMAC_OTHER_CC_FLAGS= $(CSMAMAC_CC_GLOBPTR_FLAG)  \
                  $(CSMAMAC_CC_START_ADDR_FLAG) $(CSMAMAC_CC_STACK_SIZE_FLAG) $(CSMAMAC_CC_HEAP_SIZE_FLAG)  \
                  $(CSMAMAC_LINKER_SCRIPT_FLAG) $(CSMAMAC_CC_DEBUG_FLAG) $(CSMAMAC_CC_PROFILE_FLAG) 
